Subject: Re: [PATCH 4/4] PowerPC 440EPx: Sequoia board support

From: David Gibson <[email-masked]>
Date: Thu, 16 Aug 2007 15:48:02 +1000

On Wed, Aug 15, 2007 at 01:43:09PM -0500, Josh Boyer wrote:
> On Wed, 15 Aug 2007 17:53:00 +0400
> Valentine Barshak <[email-masked]> wrote:
> 
> > David Gibson wrote:
> > >> diff -ruN linux-2.6.orig/arch/powerpc/kernel/head_44x.S linux-2.6/arch/powerpc/kernel/head_44x.S
> > >> --- linux-2.6.orig/arch/powerpc/kernel/head_44x.S	2007-08-14 17:11:19.000000000 +0400
> > >> +++ linux-2.6/arch/powerpc/kernel/head_44x.S	2007-08-14 17:18:43.000000000 +0400
> > >> @@ -217,7 +217,7 @@
> > >>  	lis	r4,interrupt_base@h	/* IVPR only uses the high 16-bits */
> > >>  	mtspr	SPRN_IVPR,r4
> > >>  
> > >> -#ifdef CONFIG_440EP
> > >> +#if defined(CONFIG_440EP) || defined(CONFIG_440EPX)
> > > 
> > > Since we should now be able to support both 440GP and 440EP boards in
> > > the same kernel, this probably needs to become a feature section.
> > > 
> > 
> > Thanks for pointing that out.
> > Talking about this, there appears to be more stuff that would need to 
> > become feature sections. There're lots of other ifdefs in 
> > arch/powerpc/kernel/head_44x.S, like ifdef CONFIG_PPC_FPU or ifdef 
> > CONFIG_440A
> > Looks like all these things have to be detected dynamically and 
> > configured properly at runtime since we tend to support more than one 
> > CPU in the same kernel.
> 
> Yes, definitely.  It's on my TODO list.  The "multiplatformness" of 44x
> at the moment needs work.

True.  Note that not all of them necessarily need to change to feature
sections, though most of them probably do:  if the code inside is
harmless, just useless for other platforms it can remain an #ifdef -
the code will run on any kernel with the relevant platform configured.

> > I think this should come as a separate patch, that replaces all these 
> > ifdefs with the FTR_SECTION stuff.
> 
> I agree.  I'd like to do this as a separate patch later rather than hold
> up Sequoia at the moment.

Fair enough.

-- 
David Gibson			| I'll have my music baroque, and my code
david AT gibson.dropbear.id.au	| minimalist, thank you.  NOT _the_ _other_
				| _way_ _around_!
http://www.ozlabs.org/~dgibson